from utils import randcell
import os

os.system('') # см. в мар.ру
# см. в мар.ру
YELLOW = '\033[33m'
RED = '\033[31m'
CYAN = '\033[36m'
GRN2 = '\033[92m'
BLD = '\033[1m'
UNDR = '\033[4m'
RST = '\033[0m'


class Helicopter: # действия вертолета
    def __init__(self, w, h): # нач. и измен. коорд. верт.
        rc = randcell(w, h)
        rx, ry = rc[0], rc[1] 
        self.x = rx
        self.y = ry
        self.w = w
        self.h = h

        self.mxtank = 1  # Вместимость воды в вертолете
        self.tank = 0  # Сколько воды сейчас
        self.score = 0 # счет
        self.lives = 20 # жизни

    def move(self, dx, dy): # изминение координат вертолета
        nx, ny = dx + self.x, dy + self.y
        if nx >= 0 and ny >= 0 and nx < self.h and ny < self.w:
            self.x, self.y = nx, ny # присвоение новых координат

    def print_stats(self): # блок для вывода статистики
        print(CYAN+"\tɄ "+RST,self.tank,"/", self.mxtank, sep="", end=" | ")
        print(UNDR+YELLOW+"Ѱ"+RST, self.score, end=" | ")
        print(RED+'♥'+RST, self.lives,'\n')

        # ╔═══════════════════════════════════════════╗
        # ║                                           ║
        # ║    ИГРА ОКОНЧЕНА. ВЫ НАБРАЛИ 100 ОЧКОВ    ║
        # ║                                           ║
        # ╚═══════════════════════════════════════════╝
    def game_over(self): # блок для вывода КОНЕЦ ИГРЫ
        os.system("cls")
        game = "    ИГРА ОКОНЧЕНА. ВЫ НАБРАЛИ " + str(self.score)+" ОЧКОВ    "
        print(YELLOW+"\n\n\n\n\n\n\t╔"+("═"*len(game))+'╗')
        print("\t║ " + " "*(len(game)-2) + " ║")
        print("\t║"+BLD+GRN2+game+RST+YELLOW+'║')
        print("\t║ " + " "*(len(game)-2) + " ║")
        print("\t╚"+("═"*len(game))+'╝\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n'+RST)
        exit(0)

    def export_data(self): # что будем записывать в файл
        return {
            "score": self.score,
            "lives": self.lives,
            "tank": self.tank,
            "mxtank": self.mxtank,
            "x": self.x,
            "y": self.y
        }

    def import_data(self, data): # присваиваем значения полученные из файла
        self.x = data['x'] or 0 
        self.y = data['y'] or 0
        self.tank = data['tank'] or 0
        self.mxtank = data['mxtank'] or 1
        self.lives = data['lives'] or 20
        self.score = data['score'] or 0
