from map import Map
from helicopter import Helicopter as Helico
from clouds import Clouds
from pynput import keyboard
import os, time, json



# -------- SETTINGS -----------
TICK_SLEEP = 0.057 # FPS
TREE_UPDATE = 50 # частота появления деревьев
FIRE_UPDATE = 100 # частота появления пожаров
CLOUDS_UPDATE = 70 # частота изминения карты облаков
MAX_W, MAX_H = 25, 10 # размер крты ширина/высота



os.system('') # надо для раскраски в win 7 без этого не фурычит
# блок цветов для раскраски
BLD = '\033[1m'
UNDR = '\033[4m'
RED = '\033[91m'
GREEN = '\033[32m'
YELLOW = '\033[33m'
CYAN = '\033[36m'
WHITE = '\033[37m'
RST = '\033[0m'

#  ♠  ▓  ₫  ░  ﬓ  ⌂  ♥  $  Ʉ  Ѱ  Ϟ  ⱺ  □  █  ○  ●
# 🌲 🌊 🚁✅ 🔥 🏥 💛 💵 🧳  🏆 ⚡️⛅️🔲⬛️ ⚪️ 🔴


field = Map(MAX_W, MAX_H)
helico = Helico(MAX_W, MAX_H)
clouds = Clouds(MAX_W, MAX_H)

tick = 1  # Номер кадра

# -------------------------
# WASD передвижение
# По ключу буквы вернет значение
MOVES = {'w': (-1, 0), 'd': (0, 1), 's': (1, 0), 'a': (0, -1),
         'ц': (-1, 0), 'в': (0, 1), 'ы': (1, 0), 'ф': (0, -1),
         keyboard.Key.up: (-1, 0),
         keyboard.Key.right: (0, 1),
         keyboard.Key.down: (1, 0),
         keyboard.Key.left: (0, -1)}


def process_key(key):  # key -нажатая клавиша
    global helico, tick, clouds, field
    
    try: # задержка при удержании клавиши 
        key_start = 0
        key_end = 400
        while key_start < key_end:
            time.sleep(TICK_SLEEP)
            keyboard.press(key)
            key_start += 1
        keyboard.release(key)
    except:
        pass

    up=keyboard.Key.up
    down=keyboard.Key.down
    left=keyboard.Key.left
    right=keyboard.Key.right

    c = key or keyboard.Key(key) # получаем нажатую кнопку
    
    if c != up:                             # если нажата
        if c != down:                       # Не одна
            if c != left:                   # из срелочек
                if c != right:              # то тогда 
                    c = key.char.lower()    # очищаем название буквы от кавычек

    if c in MOVES.keys(): # если нажата клавиша занесенная в MOVES, то двигаемся 
        dx, dy = MOVES[c][0], MOVES[c][1]
        helico.move(dx, dy)
            
    # ---------- сохранение/загрузка в/из файл(а) --------
    # u - сохранение
    # l - загрузка сохранения
    if c == 'u' or 'г': # если нажата u то записывает данные в файл
        data = {
            "helicopter": helico.export_data(),
            "clouds": clouds.export_data(),
            "field": field.export_data(),
            "tick": tick
        }
        with open("save.json", "w") as lvl: # пишем в файл
            json.dump(data, lvl)
    if c == 'l' or 'д': # если нажата l то получаем данные из файла и применяем знач.
        with open("save.json", "r") as lvl: # получение данных из файла
            data = json.load(lvl)
            helico.import_data(data['helicopter'])
            tick = data['tick']
            field.import_data(data['field'])
            clouds.import_data(data['clouds'])

# ----- обработчик пинпут ----
listener = keyboard.Listener(
    on_press=process_key)
listener.start()

# -----------------------------


while True: # цикл создания кадров
    os.system("cls")  # очищаем экран 

    print('\n\t╔═════════════════════════════════════════════════════════════╗')
    print('\t║ Условные обозначения:                                       ║')
    print('\t║ '+CYAN+'▓'+RST+' - вода      '+GREEN+'♠'+RST+' - деревья    '+YELLOW+'₫'+RST+' - вертолет    '+BLD+WHITE+'⌂'+RST+' - больница   ║')
    print('\t║ '+YELLOW+'$'+RST+' - апгрейд   '+RED+'♥'+RST+' - жизни      '+UNDR+YELLOW+'Ѱ'+RST+' - очки        '+CYAN+'Ʉ'+RST+' - топливо    ║')
    print('\t║ '+WHITE+'Ҩ'+RST+' - облака    '+YELLOW+'Ϟ'+RST+' - гроза                                     ║')
    print('\t╚═════════════════════════════════════════════════════════════╝\n')

    helico.print_stats() # счет
    field.print_map(helico, clouds) # карта 
    print("\tTICK", tick) # номер кадра
    # конец отображаемой части
    
    field.process_hilcopter(helico, clouds) # действия вертолета

    tick += 1 # счетчик кадров
    time.sleep(TICK_SLEEP)  # инициализация создания дер. огня и облак.
    if tick % TREE_UPDATE == 0:
        field.generate_tree()
    if tick % FIRE_UPDATE == 0:
        field.update_fires()
    if tick % CLOUDS_UPDATE == 0:
        clouds.update()
